
/* Includes ------------------------------------------------------------------*/
#include "stm8s.h"

/* Private defines -----------------------------------------------------------*/
static const uint32_t kPressThres =  1000; /* XCb`ꂽƔF܂ł̎Ԃ̐p
                                            * (l傫قǒԉĂȂƔȂȂ) */
static const uint32_t kAddrChannel = 0x4001; /* `lݒ̕ۑ */

/* |[g`
 *   szuĂ炱ҏW
 *   L enum `ƏԂ킹邱 */
static const struct
{
	GPIO_TypeDef*     p_type;  /* |[g^Cv       */
	GPIO_Pin_TypeDef  pin;     /* |[gԍ         */
	GPIO_Mode_TypeDef mode;    /* ftHg̃[h */
} kPort[] =
{
	             /* p_type,        pin,                      mode */
	/* kSPI_Data */ {GPIOC, GPIO_PIN_7, GPIO_MODE_OUT_PP_LOW_FAST }, /* SPI Data        */
	/* kSPI_CS   */ {GPIOC, GPIO_PIN_6, GPIO_MODE_OUT_PP_HIGH_FAST}, /* SPI Chip Select */
	/* kSPI_Clk  */ {GPIOC, GPIO_PIN_5, GPIO_MODE_OUT_PP_LOW_FAST }, /* SPI Clock       */

	/* kSW       */ {GPIOA, GPIO_PIN_3, GPIO_MODE_IN_PU_NO_IT    }, /* SW */

	/* kLED     */ {GPIOD, GPIO_PIN_2, GPIO_MODE_OUT_PP_HIGH_SLOW}, /* LED */
};

enum GPIOPort
{
	kSPI_Data,   /* SPI Data */
	kSPI_CS,     /* SPI Chip Select */
	kSPI_Clk,    /* SPI Clock */

	kSW,         /* ̓XCb`   */

	kLED,
};

/* gIe[u(rtc6705ɑSPIR}h:WX^ݒ) */
static const struct
{
	uint32_t data0;  /*  */
	uint32_t data1;  /*  */
} kChannel[] =
{
	{0x08b4431u, 0x01ffb93u}, /* 1ch 5705MHz */
	{0x08c2191u, 0x01ffb93u}, /* 2ch 5740MHz */
	{0x08c4131u, 0x01ffb93u}, /* 3ch 5745MHz */
	{0x08D1691u, 0x01ffb93u}, /* 4ch 5780MHz */
	{0x08d3631u, 0x01ffb93u}, /* 5ch 5785MHz */
	{0x08d55d1u, 0x01ffb93u}, /* 6ch 5790MHz */
	{0x08d9511u, 0x01ffb93u}, /* 7ch 5800MHz */
};


/* Private function prototypes -----------------------------------------------*/
void initGPIO(void);      /* GPIȌ */

void setLED(int bright);  /* LED */
int   getSwitchState(void);      /* XCb`̏(Ă/Ă) ̎擾 */
void  sendTo6705(uint32_t data); /* RTC6705 Ƀf[^M(WX^) */

/* Private functions ---------------------------------------------------------*/
uint8_t m_channel = 0;

void main(void)
{
	volatile int wait_cnt = 0;
	int bright = 0;
	int cnt = 0;
	uint32_t press_cnt = 0;         /* SWĂԂJEg */

	/* EEPROMݒlǂݍ */
	m_channel = FLASH_ReadByte(kAddrChannel);
	if(m_channel >= sizeof(kChannel)/sizeof(kChannel[0]) ) { m_channel = 0; } /* obt@I[o[ */

	initGPIO();

	sendTo6705(0x0000001fu);

	/* NAj[V */
 	for(cnt=0; cnt<3*sizeof(kChannel)/sizeof(kChannel[0]); ++cnt)
	{
		bright = !bright;
		setLED(bright);
		for(wait_cnt=0; wait_cnt<10000; wait_cnt+=1) {;}
	}

	/* `l̐ݒ */
	setLED(m_channel == 0);
	sendTo6705(0x0000001fu);
	sendTo6705(kChannel[m_channel].data0);
	sendTo6705(kChannel[m_channel].data1);


	/* Infinite loop */
	do
	{
		if(m_channel >= sizeof(kChannel)/sizeof(kChannel[0]) ) { m_channel = 0; } /* obt@I[o[ */

		if( getSwitchState() )
		{
			if( press_cnt < kPressThres ) { press_cnt += 1; }
			setLED(1);
		} else
		{
			press_cnt = 0;
			setLED(m_channel == 0);
		}

		if( press_cnt != kPressThres ) { continue; }
		press_cnt += 1;

		/* `lݒ̕ύX */
		m_channel += 1;
		if( m_channel >= sizeof(kChannel)/sizeof(kChannel[0]) ) { m_channel = 0; }
		setLED(m_channel == 0);
		sendTo6705(0x0000001fu);   /* Zbg */
		sendTo6705(kChannel[m_channel].data0);
		sendTo6705(kChannel[m_channel].data1);

		/* EEPROM ɏ*/
		FLASH_Unlock(FLASH_MEMTYPE_DATA);
		FLASH_EraseByte(kAddrChannel);
		FLASH_ProgramByte(kAddrChannel, m_channel);
		FLASH_Lock (FLASH_MEMTYPE_DATA);
	} while( 1 );
}

/* -------------------------------------------------------------------------- */
/* GPIO ̏ */
void initGPIO(void)
{
	int i = 0;

	for(i=0; i<sizeof(kPort)/sizeof(kPort[0]); ++i)
	{
		GPIO_Init(kPort[i].p_type, kPort[i].pin, kPort[i].mode);
	}
}

/* -------------------------------------------------------------------------- */
void setLED(int bright)
{
	if( bright != 0 ) { GPIO_WriteLow (kPort[kLED].p_type, kPort[kLED].pin); }
	else              { GPIO_WriteHigh(kPort[kLED].p_type, kPort[kLED].pin); }
}

/* -------------------------------------------------------------------------- */
/* XCb`Ă邩 */
int getSwitchState(void)
{
	/* vAbvĂāASWGND ɗ */
	/* ԂHł̃`^O΍͍sĂȂ */
	return (GPIO_ReadInputPin(kPort[kSW].p_type, kPort[kSW].pin) == RESET);
}

/* -------------------------------------------------------------------------- */
/* RTC6705̃WX^ݒ̕ύX(SPIŃf[^𑗂) */
void sendTo6705(uint32_t data)
{
 	static const uint8_t  kBits    = 25;
	volatile     uint16_t wait_cnt =  0;
	uint8_t               bit      =  0;

	GPIO_WriteLow(kPort[kSPI_Clk].p_type, kPort[kSPI_Clk].pin); /* SPI Clock Low       */
	GPIO_WriteLow(kPort[kSPI_CS ].p_type, kPort[kSPI_CS ].pin); /* SPI Chip Select Low */

	for(bit=0; bit<kBits; ++bit)
	{
		GPIO_WriteLow(kPort[kSPI_Clk].p_type, kPort[kSPI_Clk].pin); /* SPI Clock Low */

		if( data & 0x01u ) { GPIO_WriteHigh(kPort[kSPI_Data].p_type, kPort[kSPI_Data].pin); }
		else               { GPIO_WriteLow (kPort[kSPI_Data].p_type, kPort[kSPI_Data].pin); }
		data = data >> 1;

		GPIO_WriteHigh(kPort[kSPI_Clk].p_type, kPort[kSPI_Clk].pin); /* SPI Clock High */
		for(wait_cnt = 0; wait_cnt < 6; ++wait_cnt) {;}
	}

	GPIO_WriteHigh(kPort[kSPI_CS ].p_type, kPort[kSPI_CS ].pin); /* SPI Chip Select High */
	GPIO_WriteLow (kPort[kSPI_Clk].p_type, kPort[kSPI_Clk].pin); /* SPI Clock Low       */
}


#ifdef USE_FULL_ASSERT
void assert_failed(u8* file, u32 line)
{
	while (1) { ; }
}
#endif
